<?php if ( !defined( 'ABSPATH' ) ) exit;

class legal_display_class extends post_class {
  protected $model_name = 'legal_display_model';
	protected $post_type  = 'digi-legal-display';
	protected $meta_key   = '_wpdigi_legal_display';
	protected $base 			= 'digirisk/legal_display';
	protected $version 		= '0.1';

	public $element_prefix = 'LD';

	/**
	* Le constructeur
	*/
  protected function construct() {}

	/**
	* Récupères les données de l'affichage légal en base de donnée et affiches le template du formulaire
	*
	* @param object $element L'objet groupement
	*/
  public function display( $element ) {
		$data = $this->load_data( $element->id );
    require( wpdigi_utils::get_template_part( LEGAL_DISPLAY_DIR, LEGAL_DISPLAY_TEMPLATES_MAIN_DIR, 'backend', 'display' ) );
  }

  /**
  * Charges toutes les données du dernier affichage légal
	*
	* @param int $element_id L'ID du groupement
	*
	* @return array Les données chargées
  */
  public function load_data( $element_id ) {
    $data = array( 'legal_display' => array(), 'detective_work' => array(), 'occupational_health_service' => array() );
    $list_legal_display = $this->index( array( 'post_parent' => $element_id ) );

		$legal_display = !empty( $list_legal_display ) ? max($list_legal_display) : $this->show( 0 );

    $detective_work = third_class::get()->show( !empty( $legal_display->option['detective_work_id'] ) ? $legal_display->option['detective_work_id'] : 0 );
    $occupational_health_service = third_class::get()->show( !empty( $legal_display->option['occupational_health_service_id'] ) ? $legal_display->option['occupational_health_service_id'] : 0 );

    $data['legal_display'] = $legal_display;
    $data['detective_work'] = $detective_work;
		$data['detective_work']->address = address_class::get()->show( !empty( $detective_work->option['contact']['address_id'] ) ? $detective_work->option['contact']['address_id'] : 0 );
    $data['occupational_health_service'] = $occupational_health_service;
    $data['occupational_health_service']->address = address_class::get()->show( !empty( $occupational_health_service->option['contact']['address_id'] ) ? $occupational_health_service->option['contact']['address_id'] : 0 );
    return $data;
  }

	/**
	* Sauvegardes les données de l'affichage légal en base de donnée
	*
	* @param array $data Les données à sauvegarder
	*
	* @return object L'objet sauvé: affichage légal
	*/
  public function save_data( $data ) {
    // @todo : securité

    return $this->create( $data );
  }
}

legal_display_class::get();
